Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/tesselation.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -7,4 +7,5 @@
 
 #include <fstream>
+#include <assert.h>
 
 #include "helpers.hpp"
@@ -14,6 +15,10 @@
 #include "tesselation.hpp"
 #include "tesselationhelpers.hpp"
+#include "triangleintersectionlist.hpp"
 #include "vector.hpp"
+#include "vector_ops.hpp"
 #include "verbose.hpp"
+#include "Plane.hpp"
+#include "Exceptions/LinearDependenceException.hpp"
 
 class molecule;
@@ -24,11 +29,10 @@
  */
 BoundaryPointSet::BoundaryPointSet() :
-    LinesCount(0),
-    value(0.),
-    Nr(-1)
-{
-	Info FunctionInfo(__func__);
-	Log() << Verbose(1) << "Adding noname." << endl;
-};
+  LinesCount(0), value(0.), Nr(-1)
+{
+  Info FunctionInfo(__func__);
+  DoLog(1) && (Log() << Verbose(1) << "Adding noname." << endl);
+}
+;
 
 /** Constructor of BoundaryPointSet with Tesselpoint.
@@ -36,12 +40,10 @@
  */
 BoundaryPointSet::BoundaryPointSet(TesselPoint * const Walker) :
-  LinesCount(0),
-  node(Walker),
-  value(0.),
-  Nr(Walker->nr)
-{
-	Info FunctionInfo(__func__);
-  Log() << Verbose(1) << "Adding Node " << *Walker << endl;
-};
+  LinesCount(0), node(Walker), value(0.), Nr(Walker->nr)
+{
+  Info FunctionInfo(__func__);
+  DoLog(1) && (Log() << Verbose(1) << "Adding Node " << *Walker << endl);
+}
+;
 
 /** Destructor of BoundaryPointSet.
@@ -51,10 +53,11 @@
 BoundaryPointSet::~BoundaryPointSet()
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   //Log() << Verbose(0) << "Erasing point nr. " << Nr << "." << endl;
   if (!lines.empty())
-    eLog() << Verbose(2) << "Memory Leak! I " << *this << " am still connected to some lines." << endl;
+    DoeLog(2) && (eLog() << Verbose(2) << "Memory Leak! I " << *this << " am still connected to some lines." << endl);
   node = NULL;
-};
+}
+;
 
 /** Add a line to the LineMap of this point.
@@ -63,17 +66,14 @@
 void BoundaryPointSet::AddLine(BoundaryLineSet * const line)
 {
-	Info FunctionInfo(__func__);
-  Log() << Verbose(1) << "Adding " << *this << " to line " << *line << "."
-      << endl;
-  if (line->endpoints[0] == this)
-    {
-      lines.insert(LinePair(line->endpoints[1]->Nr, line));
-    }
-  else
-    {
-      lines.insert(LinePair(line->endpoints[0]->Nr, line));
-    }
+  Info FunctionInfo(__func__);
+  DoLog(1) && (Log() << Verbose(1) << "Adding " << *this << " to line " << *line << "." << endl);
+  if (line->endpoints[0] == this) {
+    lines.insert(LinePair(line->endpoints[1]->Nr, line));
+  } else {
+    lines.insert(LinePair(line->endpoints[0]->Nr, line));
+  }
   LinesCount++;
-};
+}
+;
 
 /** output operator for BoundaryPointSet.
@@ -93,10 +93,11 @@
  */
 BoundaryLineSet::BoundaryLineSet() :
-    Nr(-1)
-{
-	Info FunctionInfo(__func__);
+  Nr(-1)
+{
+  Info FunctionInfo(__func__);
   for (int i = 0; i < 2; i++)
     endpoints[i] = NULL;
-};
+}
+;
 
 /** Constructor of BoundaryLineSet with two endpoints.
@@ -107,5 +108,5 @@
 BoundaryLineSet::BoundaryLineSet(BoundaryPointSet * const Point[2], const int number)
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   // set number
   Nr = number;
@@ -118,6 +119,7 @@
   skipped = false;
   // clear triangles list
-  Log() << Verbose(0) << "New Line with endpoints " << *this << "." << endl;
-};
+  DoLog(0) && (Log() << Verbose(0) << "New Line with endpoints " << *this << "." << endl);
+}
+;
 
 /** Constructor of BoundaryLineSet with two endpoints.
@@ -140,6 +142,7 @@
   skipped = false;
   // clear triangles list
-  Log() << Verbose(0) << "New Line with endpoints " << *this << "." << endl;
-};
+  DoLog(0) && (Log() << Verbose(0) << "New Line with endpoints " << *this << "." << endl);
+}
+;
 
 /** Destructor for BoundaryLineSet.
@@ -149,5 +152,5 @@
 BoundaryLineSet::~BoundaryLineSet()
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   int Numbers[2];
 
@@ -180,5 +183,5 @@
         //Log() << Verbose(0) << *endpoints[i] << " has no more lines it's attached to, erasing." << endl;
         if (endpoints[i] != NULL) {
-          delete(endpoints[i]);
+          delete (endpoints[i]);
           endpoints[i] = NULL;
         }
@@ -187,6 +190,7 @@
   }
   if (!triangles.empty())
-    eLog() << Verbose(2) << "Memory Leak! I " << *this << " am still connected to some triangles." << endl;
-};
+    DoeLog(2) && (eLog() << Verbose(2) << "Memory Leak! I " << *this << " am still connected to some triangles." << endl);
+}
+;
 
 /** Add triangle to TriangleMap of this boundary line.
@@ -195,8 +199,9 @@
 void BoundaryLineSet::AddTriangle(BoundaryTriangleSet * const triangle)
 {
-	Info FunctionInfo(__func__);
-  Log() << Verbose(0) << "Add " << triangle->Nr << " to line " << *this << "." << endl;
+  Info FunctionInfo(__func__);
+  DoLog(0) && (Log() << Verbose(0) << "Add " << triangle->Nr << " to line " << *this << "." << endl);
   triangles.insert(TrianglePair(triangle->Nr, triangle));
-};
+}
+;
 
 /** Checks whether we have a common endpoint with given \a *line.
@@ -206,10 +211,11 @@
 bool BoundaryLineSet::IsConnectedTo(const BoundaryLineSet * const line) const
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   if ((endpoints[0] == line->endpoints[0]) || (endpoints[1] == line->endpoints[0]) || (endpoints[0] == line->endpoints[1]) || (endpoints[1] == line->endpoints[1]))
     return true;
   else
     return false;
-};
+}
+;
 
 /** Checks whether the adjacent triangles of a baseline are convex or not.
@@ -221,9 +227,9 @@
 bool BoundaryLineSet::CheckConvexityCriterion() const
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   Vector BaseLineCenter, BaseLineNormal, BaseLine, helper[2], NormalCheck;
   // get the two triangles
   if (triangles.size() != 2) {
-    eLog() << Verbose(0) << "Baseline " << *this << " is connected to less than two triangles, Tesselation incomplete!" << endl;
+    DoeLog(0) && (eLog() << Verbose(0) << "Baseline " << *this << " is connected to less than two triangles, Tesselation incomplete!" << endl);
     return true;
   }
@@ -231,9 +237,7 @@
   // have a normal vector on the base line pointing outwards
   //Log() << Verbose(0) << "INFO: " << *this << " has vectors at " << *(endpoints[0]->node->node) << " and at " << *(endpoints[1]->node->node) << "." << endl;
-  BaseLineCenter.CopyVector(endpoints[0]->node->node);
-  BaseLineCenter.AddVector(endpoints[1]->node->node);
-  BaseLineCenter.Scale(1./2.);
-  BaseLine.CopyVector(endpoints[0]->node->node);
-  BaseLine.SubtractVector(endpoints[1]->node->node);
+  BaseLineCenter = (1./2.)*((*endpoints[0]->node->node) + (*endpoints[1]->node->node));
+  BaseLine = (*endpoints[0]->node->node) - (*endpoints[1]->node->node);
+
   //Log() << Verbose(0) << "INFO: Baseline is " << BaseLine << " and its center is at " << BaseLineCenter << "." << endl;
 
@@ -241,26 +245,25 @@
   NormalCheck.Zero();
   double sign = -1.;
-  int i=0;
+  int i = 0;
   class BoundaryPointSet *node = NULL;
-  for(TriangleMap::const_iterator runner = triangles.begin(); runner != triangles.end(); runner++) {
+  for (TriangleMap::const_iterator runner = triangles.begin(); runner != triangles.end(); runner++) {
     //Log() << Verbose(0) << "INFO: NormalVector of " << *(runner->second) << " is " << runner->second->NormalVector << "." << endl;
-    NormalCheck.AddVector(&runner->second->NormalVector);
-    NormalCheck.Scale(sign);
+    NormalCheck += runner->second->NormalVector;
+    NormalCheck *= sign;
     sign = -sign;
     if (runner->second->NormalVector.NormSquared() > MYEPSILON)
-      BaseLineNormal.CopyVector(&runner->second->NormalVector);   // yes, copy second on top of first
+      BaseLineNormal = runner->second->NormalVector;   // yes, copy second on top of first
     else {
-      eLog() << Verbose(0) << "Triangle " << *runner->second << " has zero normal vector!" << endl;
+      DoeLog(0) && (eLog() << Verbose(0) << "Triangle " << *runner->second << " has zero normal vector!" << endl);
     }
     node = runner->second->GetThirdEndpoint(this);
     if (node != NULL) {
       //Log() << Verbose(0) << "INFO: Third node for triangle " << *(runner->second) << " is " << *node << " at " << *(node->node->node) << "." << endl;
-      helper[i].CopyVector(node->node->node);
-      helper[i].SubtractVector(&BaseLineCenter);
-      helper[i].MakeNormalVector(&BaseLine);  // we want to compare the triangle's heights' angles!
+      helper[i] = (*node->node->node) - BaseLineCenter;
+      helper[i].MakeNormalTo(BaseLine);  // we want to compare the triangle's heights' angles!
       //Log() << Verbose(0) << "INFO: Height vector with respect to baseline is " << helper[i] << "." << endl;
       i++;
     } else {
-      eLog() << Verbose(1) << "I cannot find third node in triangle, something's wrong." << endl;
+      DoeLog(1) && (eLog() << Verbose(1) << "I cannot find third node in triangle, something's wrong." << endl);
       return true;
     }
@@ -268,5 +271,5 @@
   //Log() << Verbose(0) << "INFO: BaselineNormal is " << BaseLineNormal << "." << endl;
   if (NormalCheck.NormSquared() < MYEPSILON) {
-    Log() << Verbose(0) << "ACCEPT: Normalvectors of both triangles are the same: convex." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "ACCEPT: Normalvectors of both triangles are the same: convex." << endl);
     return true;
   }
@@ -274,8 +277,8 @@
   double angle = GetAngle(helper[0], helper[1], BaseLineNormal);
   if ((angle - M_PI) > -MYEPSILON) {
-    Log() << Verbose(0) << "ACCEPT: Angle is greater than pi: convex." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "ACCEPT: Angle is greater than pi: convex." << endl);
     return true;
   } else {
-    Log() << Verbose(0) << "REJECT: Angle is less than pi: concave." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "REJECT: Angle is less than pi: concave." << endl);
     return false;
   }
@@ -288,10 +291,11 @@
 bool BoundaryLineSet::ContainsBoundaryPoint(const BoundaryPointSet * const point) const
 {
-	Info FunctionInfo(__func__);
-  for(int i=0;i<2;i++)
+  Info FunctionInfo(__func__);
+  for (int i = 0; i < 2; i++)
     if (point == endpoints[i])
       return true;
   return false;
-};
+}
+;
 
 /** Returns other endpoint of the line.
@@ -301,5 +305,5 @@
 class BoundaryPointSet *BoundaryLineSet::GetOtherEndpoint(const BoundaryPointSet * const point) const
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   if (endpoints[0] == point)
     return endpoints[1];
@@ -308,5 +312,6 @@
   else
     return NULL;
-};
+}
+;
 
 /** output operator for BoundaryLineSet.
@@ -314,9 +319,10 @@
  * \param &a boundary line
  */
-ostream & operator <<(ostream &ost, const  BoundaryLineSet &a)
+ostream & operator <<(ostream &ost, const BoundaryLineSet &a)
 {
   ost << "[" << a.Nr << "|" << a.endpoints[0]->node->Name << " at " << *a.endpoints[0]->node->node << "," << a.endpoints[1]->node->Name << " at " << *a.endpoints[1]->node->node << "]";
   return ost;
-};
+}
+;
 
 // ======================================== Triangles on Boundary =================================
@@ -327,11 +333,11 @@
   Nr(-1)
 {
-	Info FunctionInfo(__func__);
-  for (int i = 0; i < 3; i++)
-    {
-      endpoints[i] = NULL;
-      lines[i] = NULL;
-    }
-};
+  Info FunctionInfo(__func__);
+  for (int i = 0; i < 3; i++) {
+    endpoints[i] = NULL;
+    lines[i] = NULL;
+  }
+}
+;
 
 /** Constructor for BoundaryTriangleSet with three lines.
@@ -342,5 +348,5 @@
   Nr(number)
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   // set number
   // set lines
@@ -354,21 +360,21 @@
     // for all three lines
     for (int j = 0; j < 2; j++) { // for both endpoints
-      OrderMap.insert(pair<int, class BoundaryPointSet *> (
-          line[i]->endpoints[j]->Nr, line[i]->endpoints[j]));
+      OrderMap.insert(pair<int, class BoundaryPointSet *> (line[i]->endpoints[j]->Nr, line[i]->endpoints[j]));
       // and we don't care whether insertion fails
     }
   // set endpoints
   int Counter = 0;
-  Log() << Verbose(0) << "New triangle " << Nr << " with end points: " << endl;
+  DoLog(0) && (Log() << Verbose(0) << "New triangle " << Nr << " with end points: " << endl);
   for (PointMap::iterator runner = OrderMap.begin(); runner != OrderMap.end(); runner++) {
     endpoints[Counter] = runner->second;
-    Log() << Verbose(0) << " " << *endpoints[Counter] << endl;
+    DoLog(0) && (Log() << Verbose(0) << " " << *endpoints[Counter] << endl);
     Counter++;
   }
   if (Counter < 3) {
-    eLog() << Verbose(0) << "We have a triangle with only two distinct endpoints!" << endl;
+    DoeLog(0) && (eLog() << Verbose(0) << "We have a triangle with only two distinct endpoints!" << endl);
     performCriticalExit();
   }
-};
+}
+;
 
 /** Destructor of BoundaryTriangleSet.
@@ -378,5 +384,5 @@
 BoundaryTriangleSet::~BoundaryTriangleSet()
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   for (int i = 0; i < 3; i++) {
     if (lines[i] != NULL) {
@@ -385,12 +391,13 @@
       }
       if (lines[i]->triangles.empty()) {
-          //Log() << Verbose(0) << *lines[i] << " is no more attached to any triangle, erasing." << endl;
-          delete (lines[i]);
-          lines[i] = NULL;
+        //Log() << Verbose(0) << *lines[i] << " is no more attached to any triangle, erasing." << endl;
+        delete (lines[i]);
+        lines[i] = NULL;
       }
     }
   }
   //Log() << Verbose(0) << "Erasing triangle Nr." << Nr << " itself." << endl;
-};
+}
+;
 
 /** Calculates the normal vector for this triangle.
@@ -400,13 +407,16 @@
 void BoundaryTriangleSet::GetNormalVector(const Vector &OtherVector)
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   // get normal vector
-  NormalVector.MakeNormalVector(endpoints[0]->node->node, endpoints[1]->node->node, endpoints[2]->node->node);
+  NormalVector = Plane(*(endpoints[0]->node->node),
+                       *(endpoints[1]->node->node),
+                       *(endpoints[2]->node->node)).getNormal();
 
   // make it always point inward (any offset vector onto plane projected onto normal vector suffices)
-  if (NormalVector.ScalarProduct(&OtherVector) > 0.)
+  if (NormalVector.ScalarProduct(OtherVector) > 0.)
     NormalVector.Scale(-1.);
-  Log() << Verbose(1) << "Normal Vector is " << NormalVector << "." << endl;
-};
+  DoLog(1) && (Log() << Verbose(1) << "Normal Vector is " << NormalVector << "." << endl);
+}
+;
 
 /** Finds the point on the triangle \a *BTS through which the line defined by \a *MolCenter and \a *x crosses.
@@ -422,4 +432,5 @@
  * \return true - \a *Intersection contains intersection on plane defined by triangle, false - zero vector if outside of triangle.
  */
+
 bool BoundaryTriangleSet::GetIntersectionInsideTriangle(const Vector * const MolCenter, const Vector * const x, Vector * const Intersection) const
 {
@@ -428,52 +439,63 @@
   Vector helper;
 
-  if (!Intersection->GetIntersectionWithPlane(&NormalVector, endpoints[0]->node->node, MolCenter, x)) {
-    eLog() << Verbose(1) << "Alas! Intersection with plane failed - at least numerically - the intersection is not on the plane!" << endl;
+  try {
+    *Intersection = Plane(NormalVector, *(endpoints[0]->node->node)).GetIntersection(*MolCenter, *x);
+  }
+  catch (LinearDependenceException &excp) {
+    Log() << Verbose(1) << excp;
+    DoeLog(1) && (eLog() << Verbose(1) << "Alas! Intersection with plane failed - at least numerically - the intersection is not on the plane!" << endl);
     return false;
   }
 
-  Log() << Verbose(1) << "INFO: Triangle is " << *this << "." << endl;
-  Log() << Verbose(1) << "INFO: Line is from " << *MolCenter << " to " << *x << "." << endl;
-  Log() << Verbose(1) << "INFO: Intersection is " << *Intersection << "." << endl;
-
-  if (Intersection->DistanceSquared(endpoints[0]->node->node) < MYEPSILON) {
-    Log() << Verbose(1) << "Intersection coindices with first endpoint." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Triangle is " << *this << "." << endl);
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Line is from " << *MolCenter << " to " << *x << "." << endl);
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Intersection is " << *Intersection << "." << endl);
+
+  if (Intersection->DistanceSquared(*endpoints[0]->node->node) < MYEPSILON) {
+    DoLog(1) && (Log() << Verbose(1) << "Intersection coindices with first endpoint." << endl);
     return true;
-  }   else if (Intersection->DistanceSquared(endpoints[1]->node->node) < MYEPSILON) {
-    Log() << Verbose(1) << "Intersection coindices with second endpoint." << endl;
+  }   else if (Intersection->DistanceSquared(*endpoints[1]->node->node) < MYEPSILON) {
+    DoLog(1) && (Log() << Verbose(1) << "Intersection coindices with second endpoint." << endl);
     return true;
-  }   else if (Intersection->DistanceSquared(endpoints[2]->node->node) < MYEPSILON) {
-    Log() << Verbose(1) << "Intersection coindices with third endpoint." << endl;
+  }   else if (Intersection->DistanceSquared(*endpoints[2]->node->node) < MYEPSILON) {
+    DoLog(1) && (Log() << Verbose(1) << "Intersection coindices with third endpoint." << endl);
     return true;
   }
   // Calculate cross point between one baseline and the line from the third endpoint to intersection
-  int i=0;
+  int i = 0;
   do {
-    if (CrossPoint.GetIntersectionOfTwoLinesOnPlane(endpoints[i%3]->node->node, endpoints[(i+1)%3]->node->node, endpoints[(i+2)%3]->node->node, Intersection, &NormalVector)) {
-      helper.CopyVector(endpoints[(i+1)%3]->node->node);
-      helper.SubtractVector(endpoints[i%3]->node->node);
-      CrossPoint.SubtractVector(endpoints[i%3]->node->node);  // cross point was returned as absolute vector
-      const double s = CrossPoint.ScalarProduct(&helper)/helper.NormSquared();
-      Log() << Verbose(1) << "INFO: Factor s is " << s << "." << endl;
+    try {
+      CrossPoint = GetIntersectionOfTwoLinesOnPlane(*(endpoints[i%3]->node->node),
+                                                    *(endpoints[(i+1)%3]->node->node),
+                                                    *(endpoints[(i+2)%3]->node->node),
+                                                    *Intersection);
+      helper = (*endpoints[(i+1)%3]->node->node) - (*endpoints[i%3]->node->node);
+      CrossPoint -= (*endpoints[i%3]->node->node);  // cross point was returned as absolute vector
+      const double s = CrossPoint.ScalarProduct(helper)/helper.NormSquared();
+      DoLog(1) && (Log() << Verbose(1) << "INFO: Factor s is " << s << "." << endl);
       if ((s < -MYEPSILON) || ((s-1.) > MYEPSILON)) {
-        Log() << Verbose(1) << "INFO: Crosspoint " << CrossPoint << "outside of triangle." << endl;
+        DoLog(1) && (Log() << Verbose(1) << "INFO: Crosspoint " << CrossPoint << "outside of triangle." << endl);
         i=4;
         break;
       }
       i++;
-    } else 
+    } catch (LinearDependenceException &excp){
       break;
-  } while (i<3);
-  if (i==3) {
-    Log() << Verbose(1) << "INFO: Crosspoint " << CrossPoint << " inside of triangle." << endl;
+    }
+  } while (i < 3);
+  if (i == 3) {
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Crosspoint " << CrossPoint << " inside of triangle." << endl);
     return true;
   } else {
-    Log() << Verbose(1) << "INFO: Crosspoint " << CrossPoint << " outside of triangle." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "INFO: Crosspoint " << CrossPoint << " outside of triangle." << endl);
     return false;
   }
-};
-
-/** Finds the point on the triangle \a *BTS through which the line defined by \a *MolCenter and \a *x crosses.
- * We call Vector::GetIntersectionWithPlane() to receive the intersection point with the plane
+}
+;
+
+/** Finds the point on the triangle to the point \a *x.
+ * We call Vector::GetIntersectionWithPlane() with \a * and the center of the triangle to receive an intersection point.
+ * Then we check the in-plane part (the part projected down onto plane). We check whether it crosses one of the
+ * boundary lines. If it does, we return this intersection as closest point, otherwise the projected point down.
  * Thus we test if it's really on the plane and whether it's inside the triangle on the plane or not.
  * The latter is done as follows: We calculate the cross point of one of the triangle's baseline with the line
@@ -490,20 +512,21 @@
 
   // 1. get intersection with plane
-  Log() << Verbose(1) << "INFO: Looking for closest point of triangle " << *this << " to " << *x << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Looking for closest point of triangle " << *this << " to " << *x << "." << endl);
   GetCenter(&Direction);
-  if (!ClosestPoint->GetIntersectionWithPlane(&NormalVector, endpoints[0]->node->node, x, &Direction)) {
-    ClosestPoint->CopyVector(x);
+  try {
+    *ClosestPoint = Plane(NormalVector, *(endpoints[0]->node->node)).GetIntersection(*x, Direction);
+  }
+  catch (LinearDependenceException &excp) {
+    (*ClosestPoint) = (*x);
   }
 
   // 2. Calculate in plane part of line (x, intersection)
-  Vector InPlane;
-  InPlane.CopyVector(x);
-  InPlane.SubtractVector(ClosestPoint);  // points from plane intersection to straight-down point
-  InPlane.ProjectOntoPlane(&NormalVector);
-  InPlane.AddVector(ClosestPoint);
-
-  Log() << Verbose(2) << "INFO: Triangle is " << *this << "." << endl;
-  Log() << Verbose(2) << "INFO: Line is from " << Direction << " to " << *x << "." << endl;
-  Log() << Verbose(2) << "INFO: In-plane part is " << InPlane << "." << endl;
+  Vector InPlane = (*x) - (*ClosestPoint); // points from plane intersection to straight-down point
+  InPlane.ProjectOntoPlane(NormalVector);
+  InPlane += *ClosestPoint;
+
+  DoLog(2) && (Log() << Verbose(2) << "INFO: Triangle is " << *this << "." << endl);
+  DoLog(2) && (Log() << Verbose(2) << "INFO: Line is from " << Direction << " to " << *x << "." << endl);
+  DoLog(2) && (Log() << Verbose(2) << "INFO: In-plane part is " << InPlane << "." << endl);
 
   // Calculate cross point between one baseline and the desired point such that distance is shortest
@@ -513,22 +536,20 @@
   Vector CrossPoint[3];
   Vector helper;
-  for (int i=0;i<3;i++) {
+  for (int i = 0; i < 3; i++) {
     // treat direction of line as normal of a (cut)plane and the desired point x as the plane offset, the intersect line with point
-    Direction.CopyVector(endpoints[(i+1)%3]->node->node);
-    Direction.SubtractVector(endpoints[i%3]->node->node);
+    Direction = (*endpoints[(i+1)%3]->node->node) - (*endpoints[i%3]->node->node);
     // calculate intersection, line can never be parallel to Direction (is the same vector as PlaneNormal);
-    CrossPoint[i].GetIntersectionWithPlane(&Direction, &InPlane, endpoints[i%3]->node->node, endpoints[(i+1)%3]->node->node);
-    CrossDirection[i].CopyVector(&CrossPoint[i]);
-    CrossDirection[i].SubtractVector(&InPlane);
-    CrossPoint[i].SubtractVector(endpoints[i%3]->node->node);  // cross point was returned as absolute vector
-    const double s = CrossPoint[i].ScalarProduct(&Direction)/Direction.NormSquared();
-    Log() << Verbose(2) << "INFO: Factor s is " << s << "." << endl;
+    CrossPoint[i] = Plane(Direction, InPlane).GetIntersection(*(endpoints[i%3]->node->node), *(endpoints[(i+1)%3]->node->node));
+    CrossDirection[i] = CrossPoint[i] - InPlane;
+    CrossPoint[i] -= (*endpoints[i%3]->node->node);  // cross point was returned as absolute vector
+    const double s = CrossPoint[i].ScalarProduct(Direction)/Direction.NormSquared();
+    DoLog(2) && (Log() << Verbose(2) << "INFO: Factor s is " << s << "." << endl);
     if ((s >= -MYEPSILON) && ((s-1.) <= MYEPSILON)) {
-      CrossPoint[i].AddVector(endpoints[i%3]->node->node);  // make cross point absolute again
-      Log() << Verbose(2) << "INFO: Crosspoint is " << CrossPoint[i] << ", intersecting BoundaryLine between " << *endpoints[i%3]->node->node << " and " << *endpoints[(i+1)%3]->node->node << "." << endl;
-      const double distance = CrossPoint[i].DistanceSquared(x);
+          CrossPoint[i] += (*endpoints[i%3]->node->node);  // make cross point absolute again
+      DoLog(2) && (Log() << Verbose(2) << "INFO: Crosspoint is " << CrossPoint[i] << ", intersecting BoundaryLine between " << *endpoints[i % 3]->node->node << " and " << *endpoints[(i + 1) % 3]->node->node << "." << endl);
+      const double distance = CrossPoint[i].DistanceSquared(*x);
       if ((ShortestDistance < 0.) || (ShortestDistance > distance)) {
         ShortestDistance = distance;
-        ClosestPoint->CopyVector(&CrossPoint[i]);
+        (*ClosestPoint) = CrossPoint[i];
       }
     } else
@@ -536,25 +557,27 @@
   }
   InsideFlag = true;
-  for (int i=0;i<3;i++) {
-    const double sign = CrossDirection[i].ScalarProduct(&CrossDirection[(i+1)%3]);
-    const double othersign = CrossDirection[i].ScalarProduct(&CrossDirection[(i+2)%3]);;
-    if ((sign > -MYEPSILON) && (othersign > -MYEPSILON))  // have different sign
+  for (int i = 0; i < 3; i++) {
+    const double sign = CrossDirection[i].ScalarProduct(CrossDirection[(i + 1) % 3]);
+    const double othersign = CrossDirection[i].ScalarProduct(CrossDirection[(i + 2) % 3]);
+
+    if ((sign > -MYEPSILON) && (othersign > -MYEPSILON)) // have different sign
       InsideFlag = false;
   }
   if (InsideFlag) {
-    ClosestPoint->CopyVector(&InPlane);
-    ShortestDistance = InPlane.DistanceSquared(x);
-  } else {  // also check endnodes
-    for (int i=0;i<3;i++) {
-      const double distance = x->DistanceSquared(endpoints[i]->node->node);
+    (*ClosestPoint) = InPlane;
+    ShortestDistance = InPlane.DistanceSquared(*x);
+  } else { // also check endnodes
+    for (int i = 0; i < 3; i++) {
+      const double distance = x->DistanceSquared(*endpoints[i]->node->node);
       if ((ShortestDistance < 0.) || (ShortestDistance > distance)) {
         ShortestDistance = distance;
-        ClosestPoint->CopyVector(endpoints[i]->node->node);
+        (*ClosestPoint) = (*endpoints[i]->node->node);
       }
     }
   }
-  Log() << Verbose(1) << "INFO: Closest Point is " << *ClosestPoint << " with shortest squared distance is " << ShortestDistance << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Closest Point is " << *ClosestPoint << " with shortest squared distance is " << ShortestDistance << "." << endl);
   return ShortestDistance;
-};
+}
+;
 
 /** Checks whether lines is any of the three boundary lines this triangle contains.
@@ -564,10 +587,11 @@
 bool BoundaryTriangleSet::ContainsBoundaryLine(const BoundaryLineSet * const line) const
 {
-	Info FunctionInfo(__func__);
-  for(int i=0;i<3;i++)
+  Info FunctionInfo(__func__);
+  for (int i = 0; i < 3; i++)
     if (line == lines[i])
       return true;
   return false;
-};
+}
+;
 
 /** Checks whether point is any of the three endpoints this triangle contains.
@@ -577,10 +601,11 @@
 bool BoundaryTriangleSet::ContainsBoundaryPoint(const BoundaryPointSet * const point) const
 {
-	Info FunctionInfo(__func__);
-  for(int i=0;i<3;i++)
+  Info FunctionInfo(__func__);
+  for (int i = 0; i < 3; i++)
     if (point == endpoints[i])
       return true;
   return false;
-};
+}
+;
 
 /** Checks whether point is any of the three endpoints this triangle contains.
@@ -590,10 +615,11 @@
 bool BoundaryTriangleSet::ContainsBoundaryPoint(const TesselPoint * const point) const
 {
-	Info FunctionInfo(__func__);
-  for(int i=0;i<3;i++)
+  Info FunctionInfo(__func__);
+  for (int i = 0; i < 3; i++)
     if (point == endpoints[i]->node)
       return true;
   return false;
-};
+}
+;
 
 /** Checks whether three given \a *Points coincide with triangle's endpoints.
@@ -603,20 +629,11 @@
 bool BoundaryTriangleSet::IsPresentTupel(const BoundaryPointSet * const Points[3]) const
 {
-	Info FunctionInfo(__func__);
-	Log() << Verbose(1) << "INFO: Checking " << Points[0] << ","  << Points[1] << "," << Points[2] << " against " << endpoints[0] << "," << endpoints[1] << "," << endpoints[2] << "." << endl;
-  return (((endpoints[0] == Points[0])
-            || (endpoints[0] == Points[1])
-            || (endpoints[0] == Points[2])
-          ) && (
-            (endpoints[1] == Points[0])
-            || (endpoints[1] == Points[1])
-            || (endpoints[1] == Points[2])
-          ) && (
-            (endpoints[2] == Points[0])
-            || (endpoints[2] == Points[1])
-            || (endpoints[2] == Points[2])
-
-          ));
-};
+  Info FunctionInfo(__func__);
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Checking " << Points[0] << "," << Points[1] << "," << Points[2] << " against " << endpoints[0] << "," << endpoints[1] << "," << endpoints[2] << "." << endl);
+  return (((endpoints[0] == Points[0]) || (endpoints[0] == Points[1]) || (endpoints[0] == Points[2])) && ((endpoints[1] == Points[0]) || (endpoints[1] == Points[1]) || (endpoints[1] == Points[2])) && ((endpoints[2] == Points[0]) || (endpoints[2] == Points[1]) || (endpoints[2] == Points[2])
+
+  ));
+}
+;
 
 /** Checks whether three given \a *Points coincide with triangle's endpoints.
@@ -626,19 +643,10 @@
 bool BoundaryTriangleSet::IsPresentTupel(const BoundaryTriangleSet * const T) const
 {
-	Info FunctionInfo(__func__);
-  return (((endpoints[0] == T->endpoints[0])
-            || (endpoints[0] == T->endpoints[1])
-            || (endpoints[0] == T->endpoints[2])
-          ) && (
-            (endpoints[1] == T->endpoints[0])
-            || (endpoints[1] == T->endpoints[1])
-            || (endpoints[1] == T->endpoints[2])
-          ) && (
-            (endpoints[2] == T->endpoints[0])
-            || (endpoints[2] == T->endpoints[1])
-            || (endpoints[2] == T->endpoints[2])
-
-          ));
-};
+  Info FunctionInfo(__func__);
+  return (((endpoints[0] == T->endpoints[0]) || (endpoints[0] == T->endpoints[1]) || (endpoints[0] == T->endpoints[2])) && ((endpoints[1] == T->endpoints[0]) || (endpoints[1] == T->endpoints[1]) || (endpoints[1] == T->endpoints[2])) && ((endpoints[2] == T->endpoints[0]) || (endpoints[2] == T->endpoints[1]) || (endpoints[2] == T->endpoints[2])
+
+  ));
+}
+;
 
 /** Returns the endpoint which is not contained in the given \a *line.
@@ -648,14 +656,15 @@
 class BoundaryPointSet *BoundaryTriangleSet::GetThirdEndpoint(const BoundaryLineSet * const line) const
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   // sanity check
   if (!ContainsBoundaryLine(line))
     return NULL;
-  for(int i=0;i<3;i++)
+  for (int i = 0; i < 3; i++)
     if (!line->ContainsBoundaryPoint(endpoints[i]))
       return endpoints[i];
   // actually, that' impossible :)
   return NULL;
-};
+}
+;
 
 /** Calculates the center point of the triangle.
@@ -665,10 +674,10 @@
 void BoundaryTriangleSet::GetCenter(Vector * const center) const
 {
-	Info FunctionInfo(__func__);
+  Info FunctionInfo(__func__);
   center->Zero();
-  for(int i=0;i<3;i++)
-    center->AddVector(endpoints[i]->node->node);
-  center->Scale(1./3.);
-  Log() << Verbose(1) << "INFO: Center is at " << *center << "." << endl;
+  for (int i = 0; i < 3; i++)
+    (*center) += (*endpoints[i]->node->node);
+  center->Scale(1. / 3.);
+  DoLog(1) && (Log() << Verbose(1) << "INFO: Center is at " << *center << "." << endl);
 }
 
